;; Compile: bigloo -o stm -ljapi -lwsock32 stm.scm

(module mouselistener
	(include "japi/japi.sch")
	(main x-mouselistener))

(define (rect canvas pressed released)
  (let* [ (px (j_getmousex pressed))
          (py (j_getmousey pressed))
          (x  (j_getmousex released) )
          (y   (j_getmousey released) )
          (w  (- x px))
          (h  (- y py)) ]
     (j_drawrect canvas px py w h)) )

        
(define (x-mouselistener args)
     (j_start)
  (let* [ (frame (j_frame "move and drag the Mouse")) 
	  (canvas (j_canvas frame 400 200)) 	  
	  (pressed (j_mouselistener canvas J_PRESSED)) 
	  (released (j_mouselistener canvas J_RELEASED)) ]

    (j_setsize frame 430 240)
    (j_setpos canvas 10 30)
    
    (j_show frame)
             
    ;; Waiting for actions 
    (do ((obj (j_nextaction)(j_nextaction)))
	((= obj frame) (j_quit))
      (cond [ (= obj pressed)
	      (j_drawcircle canvas  
	            (j_getmousex pressed) 
	            (j_getmousey pressed) 
	            30 #;radius )]
	    [  (= obj released)
	       (rect canvas pressed released)])   
    ); end of do 
   ); end of let* 
) ;; end of definition

