;; Compile: bigloo -o engine -ljapi -lwsock32 engine.scm

(module engine (include "japi/japi.sch")
	(main x-animation))

(define iFiles
  '("o1.jpg" "o2.jpg" "o3.jpg" "o4.jpg" "o5.jpg" "o6.jpg"))

(define (x-animation argv)
  (j_start)
  (let* [ (fr (j_frame "Hello"))
          (canvas (j_canvas fr 260 400))
          (all-images (map j_loadimage iFiles)) ]
     (j_setsize fr 270 440)
     (j_setpos canvas 10 30)
     (j_show fr)
      
     (define (next images)
        (cond [ (null? images) all-images]
              [ (null? (cdr images)) all-images]
              [else (cdr images)]))
     
     (do [ (images all-images (next images))
           (event (j_getaction) (j_getaction)) ]
         [(= event fr) (j_quit)]
         
         (j_sleep 500)
         (j_drawimage canvas (car images) 10 0))
   );end of let*
 );end of definition
 


    


